
-- 1) As funes precedidas pelos esquemas public ou pg_catalog devem ser criadas diretamente na base template1
-- 2) As funes no precedidas pelo esquema devem assumir o esquema do usurio logado (TOTALL, ANSISYS...)

CREATE OR REPLACE FUNCTION pg_catalog.instr(varchar,varchar,integer,integer) RETURNS integer AS '
DECLARE
    string ALIAS FOR $1;
    string_to_search ALIAS FOR $2;
    beg_index ALIAS FOR $3;
    occur_index ALIAS FOR $4;
    pos integer NOT NULL DEFAULT 0;
    occur_number integer NOT NULL DEFAULT 0;
    temp_str varchar;
    beg integer;
    i integer;
    length integer;
    ss_length integer;
BEGIN
    IF string is NULL or string_to_search IS NULL THEN
       RETURN NULL;
    END IF;
    IF beg_index > 0 THEN
        beg := beg_index;
        temp_str := substring(string FROM beg_index);

        FOR i IN 1..occur_index LOOP
            pos := position(string_to_search IN temp_str);

            IF i = 1 THEN
                beg := beg + pos - 1;
            ELSE
                beg := beg + pos;
            END IF;

            temp_str := substring(string FROM beg + 1);
        END LOOP;

        IF pos = 0 THEN
            RETURN 0;
        ELSE
            RETURN beg;
        END IF;
    ELSE
        ss_length := char_length(string_to_search);
        length := char_length(string);
        beg := length + beg_index - ss_length + 2;

        WHILE beg > 0 LOOP
            temp_str := substring(string FROM beg FOR ss_length);
            pos := position(string_to_search IN temp_str);

            IF pos > 0 THEN
                occur_number := occur_number + 1;

                IF occur_number = occur_index THEN
                    RETURN beg;
                END IF;
            END IF;

            beg := beg - 1;
        END LOOP;

        RETURN 0;
    END IF;
END;
' language 'plpgsql';


CREATE OR REPLACE FUNCTION pg_catalog.instr(varchar,varchar,integer) RETURNS integer AS '
DECLARE
    string ALIAS FOR $1;
    string_to_search ALIAS FOR $2;
    beg_index ALIAS FOR $3;
    pos integer NOT NULL DEFAULT 0;
    temp_str varchar;
    beg integer;
    length integer;
    ss_length integer;
BEGIN
    IF string is NULL or string_to_search IS NULL THEN
       RETURN NULL;
    END IF;

    IF beg_index > 0 THEN

       temp_str := substring(string FROM beg_index);
       pos := position(string_to_search IN temp_str);

       IF pos = 0 THEN
          RETURN 0;
      ELSE
          RETURN pos + beg_index - 1;
      END IF;
    ELSE
       ss_length := char_length(string_to_search);
       length := char_length(string);
       beg := length + beg_index - ss_length + 2;

       WHILE beg > 0 LOOP

           temp_str := substring(string FROM beg FOR ss_length);
          pos := position(string_to_search IN temp_str);

          IF pos > 0 THEN
             RETURN beg;
          END IF;

          beg := beg - 1;
       END LOOP;
       RETURN 0;
    END IF;
END;
' language 'plpgsql';


CREATE OR REPLACE FUNCTION pg_catalog.instr(varchar,varchar) RETURNS integer AS '
DECLARE
    pos integer;
BEGIN
    pos:= instr($1,$2,1);
    RETURN pos;
END;
' language 'plpgsql';


CREATE OR REPLACE FUNCTION pg_catalog.trunc(timestamptz)
RETURNS Date AS '
BEGIN
 RETURN date_trunc(''day'', $1);
END;
' language 'plpgsql';


CREATE OR REPLACE FUNCTION pg_catalog.TO_NUMBER(varchar) RETURNS Integer AS '
BEGIN
 RETURN TO_NUMBER($1, ''9999999999999999''); 
END;
' language 'plpgsql';

CREATE OR REPLACE FUNCTION pg_catalog.TO_CHAR(numeric) RETURNS VarChar AS '
BEGIN
 RETURN CAST($1 AS VARCHAR);
END;
' language 'plpgsql';

CREATE OR REPLACE FUNCTION pg_catalog.to_char(varchar) RETURNS varchar AS '
BEGIN
 RETURN $1;
END
' language 'plpgsql';

CREATE OR REPLACE FUNCTION PUBLIC.TO_DATE(text, text) RETURNS TIMESTAMP
AS '
DECLARE
  dRetorno TIMESTAMP;
BEGIN
 IF UPPER($2)=''DD/MM/YYYY'' THEN 
    dRetorno:=TRUNC(pg_Catalog.TO_TIMESTAMP($1,UPPER($2)));
 ELSE
    dRetorno:=pg_Catalog.TO_TIMESTAMP($1,UPPER($2));
 END IF;
 RETURN dRetorno;
END;
' language 'plpgsql' STRICT IMMUTABLE;

